#include <amxmodx>
#include <amxmisc>
#include <sqlx>

setupDB(const szDB[])<mysql>{
#pragma unused szDB
}
prepareConnection()<mysql>{}

tryCreateTables()<mysql>{
	new iLen = 0;
	iLen += formatex(gszQuery[iLen], giMax-iLen, "CREATE TABLE IF NOT EXISTS `%s` (", gszUsersTable);
	iLen += copy(gszQuery[iLen], giMax-iLen, 		"id	 INT(11) UNSIGNED AUTO_INCREMENT, ");
	iLen += copy(gszQuery[iLen], giMax-iLen, 		"steamid	VARCHAR(32) NOT NULL, ");
	iLen += copy(gszQuery[iLen], giMax-iLen, 		"nickname	VARCHAR(32) NOT NULL, ");
	iLen += copy(gszQuery[iLen], giMax-iLen, 		"ip		VARCHAR(32) NOT NULL, ");
	iLen += copy(gszQuery[iLen], giMax-iLen, 		"firstConnect	DATETIME NOT NULL, ");
	iLen += copy(gszQuery[iLen], giMax-iLen, 		"playedTime	INT(11)	NOT NULL DEFAULT 0, ");
	iLen += copy(gszQuery[iLen], giMax-iLen, 		"PRIMARY KEY(id) ");
	iLen += copy(gszQuery[iLen], giMax-iLen, 		")");
	
	SQL_ThreadQuery(gTuple, "handleCreateQuery", gszQuery);
	
	
	iLen = 0;
	iLen += formatex(gszQuery[iLen], giMax-iLen, "CREATE TABLE IF NOT EXISTS `%s` (", gszStatsTable);
	iLen += copy(gszQuery[iLen], giMax-iLen, 		"pid	INT(11) UNSIGNED NOT NULL, ");
	iLen += copy(gszQuery[iLen], giMax-iLen, 		"wid	INT(11) NOT NULL, ");
	iLen += copy(gszQuery[iLen], giMax-iLen, 		"kills	INT(11) NOT NULL, ");
	iLen += copy(gszQuery[iLen], giMax-iLen, 		"hs	INT(11) NOT NULL, ");
	iLen += copy(gszQuery[iLen], giMax-iLen, 		"PRIMARY KEY(pid, wid), ");
	iLen += formatex(gszQuery[iLen], giMax-iLen, 		"FOREIGN KEY(pid) REFERENCES `%s`(id) ON DELETE CASCADE ",gszUsersTable);
	iLen += copy(gszQuery[iLen], giMax-iLen, 		")");
	
	SQL_ThreadQuery(gTuple, "handleCreateQuery", gszQuery);
}
//Select pid
public handleSelectQuery(failstate, Handle:query, error[], errnum, data[], size)<mysql>{
	if(failstate != TQUERY_SUCCESS){
		log_amx("MySQL Select error: %s",error);
		return;
	}
	new id = data[0];
	if(!is_user_connected(id))
		return;
		
		
	if(SQL_NumRows(query)){
		new szDate[64];
		SQL_ReadResult(query, 1, szDate, 63);
		giFirstConnect[id] = parse_time(szDate, DATE_FORMAT);
		giPlayedTime[id] = SQL_ReadResult(query, 2);
		
		client_authorized_sql(id, SQL_ReadResult(query, 0));
	}else{
		new szSteamid[32], szName[64], szIp[32];
		get_user_authid(id, szSteamid, 31);
		get_user_name(id, szName, 31);
		get_user_ip(id, szIp, 31, 1);
		SQL_PrepareString(szName, szName, 63);
		
		formatex(gszQuery, giMax, "INSERT INTO `%s` VALUES (0, '%s', '%s', '%s', NOW(), 0)",
			gszUsersTable, szSteamid, szName, szIp);
		SQL_ThreadQuery(gTuple, "handleInsertQuery", gszQuery, data, size);
	}
}

saveWeaponData(id)<mysql>{
	new iLen=0;
	for(new i=1;i<31+MAX_CUSTOM;i++)
		if(gbWeaponChanged[id][i]){
			iLen += formatex(gszQuery[iLen], giMax-iLen, 
			"INSERT INTO `%s` VALUES (%d, %d, %d, %d) ON DUPLICATE KEY UPDATE kills=%d,hs=%d;",
				gszStatsTable, giPid[id], i, giWeaponStats[id][i][0], giWeaponStats[id][i][1],
				giWeaponStats[id][i][0], giWeaponStats[id][i][1]);
		}
	SQL_ThreadQuery(gTuple, "handleSaveQuery", gszQuery);
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1045\\ f0\\ fs16 \n\\ par }
*/
