#include <amxmodx>

//Create Handler
public handleCreateQuery(failstate, Handle:query, error[], errnum, data[], size)<mysql, sqlite>{
	if(failstate != TQUERY_SUCCESS)
		log_amx("SQL Creation error: %s",error);
}
//Insert user
public handleInsertQuery(failstate, Handle:query, error[], errnum, data[], size)<mysql, sqlite>{
	if(failstate != TQUERY_SUCCESS){
		log_amx("SQL Insert error: %s",error);
		return;
	}
	
	new id = data[0];
	if(!is_user_connected(id))
		return;
		
	giFirstConnect[id] = get_systime();
	giPlayedTime[id] = 0;
	client_authorized_sql(id, SQL_GetInsertId(query));
}

//Select pid
public handleLoadStatsQuery(failstate, Handle:query, error[], errnum, data[], size)<mysql, sqlite>{
	if(failstate != TQUERY_SUCCESS){
		log_amx("SQL Load Stats error: %s",error);
		return;
	}
	
	new id = data[0];
	if(!is_user_connected(id))
		return;
		
	new wid;
	while(SQL_MoreResults(query)){
		wid = SQL_ReadResult(query, 0);
		giWeaponStats[id][wid][0] = SQL_ReadResult(query, 1);
		giWeaponStats[id][wid][1] = SQL_ReadResult(query, 2);
		
		SQL_NextRow(query);
	}
	
	gbLoaded[id] = true;
	
	new iRet;
	ExecuteForward(gfwDataLoaded, iRet, id);
}
//Save query
public handleSaveQuery(failstate, Handle:query, error[], errnum, data[], size)<mysql, sqlite>{
	if(failstate != TQUERY_SUCCESS){
		log_amx("SQL Save error: %s",error);
		return;
	}
}

loadWeaponStats(id)<mysql, sqlite>{
	if(!is_user_connected(id) || !giPid[id]) return;
	
	formatex(gszQuery, giMax, "SELECT wid,kills,hs FROM `%s` WHERE pid = %d",
			gszStatsTable, giPid[id]);
	
	new data[1];
	data[0] = id;
	SQL_ThreadQuery(gTuple, "handleLoadStatsQuery", gszQuery, data, sizeof(data));
}

savePlayedTime(id)<mysql, sqlite>{
	formatex(gszQuery, giMax, "UPDATE `%s` SET playedTime = %d WHERE id = %d;",
			gszUsersTable, getPlayedTime(id), giPid[id]);
	SQL_ThreadQuery(gTuple, "handleSaveQuery", gszQuery);
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1045\\ f0\\ fs16 \n\\ par }
*/
