#include <amxmodx>
#include <amxmisc>
#include <sqlx>

setupDB(const szDB[])<sqlite>{
	if(!file_exists(szDB)){
		new fp = fopen(szDB, "w");
		if(!fp){
			new szMsg[128];
			formatex(szMsg, 127, "%s file not found and cant be created. Do it mannualy", szDB);
			set_fail_state(szMsg);
		}
		fclose(fp);
	}
}

prepareConnection()<sqlite>{	
	SQL_ThreadQuery(gTuple, "handleCreateQuery", "PRAGMA integrity_check" );
	SQL_ThreadQuery(gTuple, "handleCreateQuery", "PRAGMA synchronous = 1" );
}
tryCreateTables()<sqlite>{
	new iLen = 0;
	iLen += formatex(gszQuery[iLen], giMax-iLen, "CREATE TABLE IF NOT EXISTS `%s` (", gszUsersTable);
	iLen += copy(gszQuery[iLen], giMax-iLen, 		"id	 	INTEGER PRIMARY KEY, ");
	iLen += copy(gszQuery[iLen], giMax-iLen, 		"steamid	TEXT 	NOT NULL, ");
	iLen += copy(gszQuery[iLen], giMax-iLen, 		"nickname	TEXT 	NOT NULL, ");
	iLen += copy(gszQuery[iLen], giMax-iLen, 		"ip		TEXT 	NOT NULL, ");
	iLen += copy(gszQuery[iLen], giMax-iLen, 		"firstConnect	TEXT 	NOT NULL, ");
	iLen += copy(gszQuery[iLen], giMax-iLen, 		"playedTime	INTEGER		NOT NULL ");
	iLen += copy(gszQuery[iLen], giMax-iLen, 		")");
	
	SQL_ThreadQuery(gTuple, "handleCreateQuery", gszQuery);
	
	
	iLen = 0;
	iLen += formatex(gszQuery[iLen], giMax-iLen, "CREATE TABLE IF NOT EXISTS `%s` (", gszStatsTable);
	iLen += copy(gszQuery[iLen], giMax-iLen, 		"pid	INTEGER NOT NULL, ");
	iLen += copy(gszQuery[iLen], giMax-iLen, 		"wid	INTEGER NOT NULL, ");
	iLen += copy(gszQuery[iLen], giMax-iLen, 		"kills	INTEGER NOT NULL, ");
	iLen += copy(gszQuery[iLen], giMax-iLen, 		"hs	INTEGER NOT NULL, ");
	iLen += copy(gszQuery[iLen], giMax-iLen, 		"PRIMARY KEY(pid, wid), ");
	iLen += formatex(gszQuery[iLen], giMax-iLen, 		"FOREIGN KEY(pid) REFERENCES `%s`(id)",gszUsersTable);
	iLen += copy(gszQuery[iLen], giMax-iLen, 		")");
	
	SQL_ThreadQuery(gTuple, "handleCreateQuery", gszQuery);
}

public handleSelectQuery(failstate, Handle:query, error[], errnum, data[], size)<sqlite>{
	if(failstate != TQUERY_SUCCESS){
		log_amx("MySQL Select error: %s",error);
		return;
	}
	new id = data[0];
	if(!is_user_connected(id))
		return;
		
		
	if(SQL_NumRows(query)){
		new szDate[64];
		SQL_ReadResult(query, 1, szDate, 63);
		giFirstConnect[id] = parse_time(szDate, DATE_FORMAT);
		giPlayedTime[id] = SQL_ReadResult(query, 2);
		
		client_authorized_sql(id, SQL_ReadResult(query, 0));
	}else{
		new szSteamid[32], szName[64], szIp[32];
		get_user_authid(id, szSteamid, 31);
		get_user_name(id, szName, 31);
		get_user_ip(id, szIp, 31, 1);
		SQL_PrepareString(szName, szName, 63);
		
		new szDate[64];
		format_time ( szDate, 63, DATE_FORMAT);
		formatex(gszQuery, giMax, "INSERT INTO `%s` VALUES (NULL, '%s', '%s', '%s', '%s', 0)",
			gszUsersTable, szSteamid, szName, szIp, szDate);
		SQL_ThreadQuery(gTuple, "handleInsertQuery", gszQuery, data, size);
	}
}
saveWeaponData(id)<sqlite>{
	new iLen=0;
	for(new i=1;i<31+MAX_CUSTOM;i++){
		if(gbWeaponChanged[id][i]){
			iLen += formatex(gszQuery[iLen], giMax-iLen,"INSERT OR IGNORE INTO `%s` VALUES (%d, %d, %d, %d);"
			, gszStatsTable, giPid[id], i, giWeaponStats[id][i][0], giWeaponStats[id][i][1]);
			
			iLen += formatex(gszQuery[iLen], giMax-iLen,"UPDATE `%s` SET kills=%d, hs=%d WHERE pid=%d AND wid=%d;"
			, gszStatsTable, giWeaponStats[id][i][0], giWeaponStats[id][i][1], giPid[id], i );
		}
	}
	SQL_ThreadQuery(gTuple, "handleSaveQuery", gszQuery);
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1045\\ f0\\ fs16 \n\\ par }
*/
