/**
 * Dynamic HUD version
 */

#include <amxmodx>
#include <amxmisc>
#tryinclude <dhud>

new Array:__gChallenges[33];
new Array:__gAwards[33];
new Array:__gColors[33];
new Array:__gID[33];
new giLastID[33];


new fwStartInfo;

new dhuds[33][2];
new Float:fBase = 0.5;
new Float:fOffset[5] = {
	0.0, 0.06
}

new gszChallenge[33][CHALLENGE_LEN];
new gszAward[33][AWARD_LEN];

new gbDisplaying[33];

new giLastColor[33][3];

__init_dhud_deque() {
	for(new i=1;i<33;i++){
		__gChallenges[i] = ArrayCreate(CHALLENGE_LEN);
		__gAwards[i] = ArrayCreate(AWARD_LEN);
		__gColors[i] = ArrayCreate(3);
		__gID[i] = ArrayCreate();
		
		#if defined _dHUD_included
		for(new j=0;j<2;j++)
			dhuds[i][j] = DHUD_create();
		#endif
		
		setColor(i, {255, 255, 255});
		
		giLastID[i] = 1;
	}
	
	fwStartInfo = CreateMultiForward("challenge_dhud_displaying", ET_CONTINUE, FP_CELL, FP_CELL);
}

setColor(id, iColor[3]){
#if defined _dHUD_included
	new iColor2[3];
	new iColor3[3];
	
	iColor2[0] = iColor[0] / 5;
	iColor2[1] = iColor[1] / 5;
	iColor2[2] = iColor[2] / 5;
	
	iColor3[0] = iColor[0] / 11;
	iColor3[1] = iColor[1] / 11;
	iColor3[2] = iColor[2] / 11;
	
	giLastColor[id][0] = iColor[0];
	giLastColor[id][1] = iColor[1];
	giLastColor[id][2] = iColor[2];
	
	for(new i=0;i<2;i++){	
		DHUD_setFrame(dhuds[id][i], 2, iColor, 0.07, fBase+fOffset[i], 13-i);
		DHUD_setFrame(dhuds[id][i], 1, iColor2, 0.03, fBase+fOffset[i]);
		DHUD_setFrame(dhuds[id][i], 0, iColor3, 0.0, fBase+fOffset[i]);
	}
#endif
}

printInfoDHUD(id, const szChallenge[], const szAward[], const iColor[] = {255, 255, 255}){
	
	static initialized = 0;
	if(!initialized){
		__init_dhud_deque();
		initialized = 1;
	}
	
	if(id == 0) return 0;
	
	new _szChallenge[CHALLENGE_LEN];
	copy(_szChallenge, CHALLENGE_LEN-1, szChallenge);
	
	new _szAward[AWARD_LEN];
	copy(_szAward, AWARD_LEN-1, szAward);
	
	new ID = giLastID[id]++;
	ArrayPushString(__gChallenges[id], _szChallenge);
	ArrayPushString(__gAwards[id], _szAward);
	ArrayPushArray(__gColors[id], iColor);
	ArrayPushCell(__gID[id], ID);
	
	displayInfo(id);
	return ID;
}

public display1(id){
	DHUD_display(id, dhuds[id][1], 0.1, 2, "%s", gszAward[id]);
}

public fwStopAnimation(id, dhud, bool:finished){
	
	if(dhud == dhuds[id][1]){
		gbDisplaying[id] = false;
		
		if(finished)
			displayInfo(id);
	}
}

displayInfo(id){
	if(!ArraySize(__gChallenges[id])) return;
	
	if(!gbDisplaying[id]){
		gbDisplaying[id] = true;
		
#if defined _dHUD_included
		DHUD_clear(id, dhuds[id][0]);
		DHUD_clear(id, dhuds[id][1]);
#endif
		ArrayGetString(__gChallenges[id], 0, gszChallenge[id], CHALLENGE_LEN-1);
		ArrayDeleteItem(__gChallenges[id], 0);
		
		ArrayGetString(__gAwards[id], 0, gszAward[id], AWARD_LEN-1);
		ArrayDeleteItem(__gAwards[id], 0);
		
		new iColor[3];
		ArrayGetArray(__gColors[id], 0, iColor);
		ArrayDeleteItem(__gColors[id], 0);
		
		new ID = ArrayGetCell(__gID[id], 0);
		ArrayDeleteItem(__gID[id], 0);
		
		ExecuteForward(fwStartInfo, ID, id, ID);
		
		if(giLastColor[id][0] != iColor[0] || giLastColor[id][1] != iColor[1] || giLastColor[id][2] != iColor[2])
			setColor(id, iColor);
	
		
#if defined _dHUD_included		
		DHUD_display(id, dhuds[id][0], 0.1, 1, "%s", gszChallenge[id]);	
#endif
		set_task(0.1, "display1", id)
	}
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1045\\ f0\\ fs16 \n\\ par }
*/
